<template>
  <section class="playPage">
    <div class="playPage__left">
      <section class="topHeading">
        Powered by DEEZER and Vue.js.
        <section class="small">Audio tracks are limited for 30 seconds.</section>
      </section>
      <section class="animated-placeholder" width="546" height="250" v-if="!isReady" v-bind:style="{ 'border-radius': 0 }"></section>
      <active-track v-if="isReady"></active-track>
      <h2 class="tracksHeader" v-if="state.currentPlaylistName">{{state.currentPlaylistName}}</h2>
      <section class="playPage__content">
        <spinner v-if="state.processing"></spinner>
        <section class="trackRows" v-if="!state.processing">
          <track-row 
            v-for="track in state.tracks" 
            v-bind:key="track.id"
            v-bind:track="track"
            v-bind:isPlaying="audioState.isPlaying"
            v-bind:isActive="audioState.activeTrack && track.id == audioState.activeTrack.id">
          </track-row>
        </section>
      </section>
    </div>
    <div class="playPage__right">
      <sidebar></sidebar>
    </div>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import { State } from 'vuex-class';
import { Watch } from 'vue-property-decorator';

@Component()
export default class PlayPage extends Vue {
  @State(state => state.play)
  state;
  @State(state => state.audio)
  audioState;
  isReady = false;

  @Watch('$route')
  routeChanged() {
    this.handleRouteParams();
  }

  async handleRouteParams() {
    const { type, id, trackId } = this.$route.params;
    if (!type || !id) {
      if (!this.state.tracks.length) {
        await this.$store.dispatch('fetchPlayData');
      }
      this.isReady = true;
      return;
    }
    const actionMap = {
      album: 'fetchAlbum',
      playlist: 'fetchPlaylist',
      genre: 'fetchGenreTracks',
      artist: 'fetchArtistTracks',
    };
    await this.$store.dispatch(actionMap[type], id);
    let activeTrack;
    if (trackId) {
      activeTrack = this.state.tracks.find(track => Number(track.id) === Number(trackId));
      if (!activeTrack) {
        activeTrack = this.state.tracks[0];
      }
    } else {
      activeTrack = this.state.tracks[0];
    }
    if (activeTrack) {
      this.$store.dispatch('setActiveTrack', activeTrack);
      this.$store.dispatch('play', activeTrack);
      this.isReady = true;
    }
  }

  mounted() {
    this.handleRouteParams();
  }
}
</script>

<style lang="stylus">
.playPage
  display flex

  &__left
  &__right
    flex 0 0 50%

  .topHeading
    height 72px
    max-height 72px
    padding 0 0 0 16px
    display flex
    flex-direction column
    justify-content center
    align-items flex-start
    font-size 15px
    font-weight bold
    text-transform uppercase

    .small
      padding-top 2px
      color rgb(86,92,105)
      font-size 10px
      font-weight 500
      line-height 1
      text-transform none

  &__content
    display flex

  .trackRows
    width 100%

  .tracksHeader
    display inline-block
    margin-top 16px
    margin-bottom 16px
    padding 6px 14px
    color #000
    background-color yellow
    font-size 14px
    font-weight 900
    font-family 'Encode Sans', sans-serif

  &__right
    padding-left 12px
</style>

